<template>
  <div class="flex flex-col ">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 items-center justify-center">
      <div class="inline-block">
        <a-input label="Amount of events:" placeholder="amount" :validators="amoutValidators" v-model="amount" />
        <submit-button value="find" @click="execute" />
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <Masons title="Result" />
    </div>
  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { positiveNumberValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import SimpleSqlQueries from '@/assets/SimpleQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import Masons from '@/components/Masons.vue';
import { mapMutations } from 'vuex';
import { add_masons } from '@/components/helpers.js';
import axiosClient from '@/axiosClient';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Masons,
  },
  data() {
    return {
      amoutValidators: [positiveNumberValidator],
      question_str: SimpleSqlQueries[0].question,
      sql_query: SimpleSqlQueries[0].query,
      amount: undefined,
    }
  },
  methods: {
    ...mapMutations(["clearMasons"]),
    execute() {
      axiosClient.get('simple-query/1', { headers: { n: this.amount } })
        .then((response) => {
          this.clearMasons()
          add_masons(response)
        })
    }
  },
  mounted() {
    this.clearMasons()
  }
}


</script>